Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Attributes/SwapPositionMoveAttribute.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Attributes/SwapPositionMoveAttribute.cs	(revision 9494)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Attributes/SwapPositionMoveAttribute.cs	(revision 9495)
@@ -29,11 +29,13 @@
   public class SwapPositionMoveAttribute : MultiComponentVectorMoveAttribute {
     [Storable]
+    public int AffectedGroup { get; protected set; }
+    [Storable]
     public int Index1 { get; protected set; }
     [Storable]
     public int Index2 { get; protected set; }
     [Storable]
-    public int ItemIndex1 { get; protected set; }
+    public int ItemID1 { get; protected set; }
     [Storable]
-    public int ItemIndex2 { get; protected set; }
+    public int ItemID2 { get; protected set; }
 
     [StorableConstructor]
@@ -41,16 +43,18 @@
     protected SwapPositionMoveAttribute(SwapPositionMoveAttribute original, Cloner cloner)
       : base(original, cloner) {
+        this.AffectedGroup = original.AffectedGroup;
         this.Index1 = original.Index1;
         this.Index2 = original.Index2;
-      this.ItemIndex1 = original.ItemIndex1;
-      this.ItemIndex2 = original.ItemIndex2;
+      this.ItemID1 = original.ItemID1;
+      this.ItemID2 = original.ItemID2;
     }
-    public SwapPositionMoveAttribute() : this(-1, -1, -1, -1, -1) { }
-    public SwapPositionMoveAttribute(int index1, int index2, int itemIndex1, int itemIndex2, double moveQuality)
+    public SwapPositionMoveAttribute() : this(-1, -1, -1, -1, -1, -1) { }
+    public SwapPositionMoveAttribute(int affectedGroup, int index1, int index2, int itemID1, int itemID2, double moveQuality)
       : base(moveQuality) {
+        AffectedGroup = affectedGroup;
         Index1 = index1;
         Index2 = index2;
-        ItemIndex1 = itemIndex1;
-        ItemIndex2 = itemIndex2;
+        ItemID1 = itemID1;
+        ItemID2 = itemID2;
     }
 
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/ExhaustiveMCVTripleMoveGenerator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/ExhaustiveMCVTripleMoveGenerator.cs	(revision 9494)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/ExhaustiveMCVTripleMoveGenerator.cs	(revision 9495)
@@ -40,27 +40,12 @@
     }
 
-    public static IEnumerable<MultiComponentVectorMove> GenerateMCVTripleMoves(MultiComponentVectorEncoding mcv) {
-      int nrOfBins = 0;
-      foreach (var pi in mcv.PackingInformations) {
-        if (pi.AssignedBin > nrOfBins)
-          nrOfBins = pi.AssignedBin;
-      }
-      nrOfBins++;
-      Dictionary<int, List<int>> indexesPerBin = new Dictionary<int, List<int>>();
-      for (int i = 0; i < mcv.PackingInformations.Count; i++) {
-        int currentBin = mcv.PackingInformations[i].AssignedBin;
-        if (!indexesPerBin.ContainsKey(currentBin))
-          indexesPerBin[currentBin] = new List<int>();
-        indexesPerBin[currentBin].Add(i);
-      }
-                                                        
-      for (int index = 0; index < mcv.PackingInformations.Count; index++) { 
-        for (int group = 0; group < nrOfBins; group++) {
-          foreach (int targetIndex in indexesPerBin[group]) {
-            yield return new MCVTripleMove(index, false, group, targetIndex, mcv);
-            yield return new MCVTripleMove(index, true, group, targetIndex, mcv);
-          }
-        }
-      }
+    public static IEnumerable<MultiComponentVectorMove> GenerateMCVTripleMoves(MultiComponentVectorEncoding mcv) {  
+      foreach (var oldGroup in mcv.PackingInformations) 
+        for (int sourceIndex = 0; sourceIndex < oldGroup.Value.Count; sourceIndex++) 
+          foreach (var newGroup in mcv.PackingInformations) 
+            for (int targetIndex = 0; targetIndex < newGroup.Value.Count; targetIndex++) {
+              yield return new MCVTripleMove(oldGroup.Key, newGroup.Key, sourceIndex, targetIndex, false, mcv);
+              yield return new MCVTripleMove(oldGroup.Key, newGroup.Key, sourceIndex, targetIndex, true, mcv);
+            }
     }
 
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/ChangePositionMove.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/ChangePositionMove.cs	(revision 9494)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/ChangePositionMove.cs	(revision 9495)
@@ -24,4 +24,5 @@
 using HeuristicLab.Encodings.PackingEncoding.MultiComponentVector;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.BinPacking.Interfaces;
 
 namespace HeuristicLab.Encodings.PackingEncoding.MultiComponentVector {
@@ -29,4 +30,6 @@
   [StorableClass]
   public class ChangePositionMove : MultiComponentVectorMove {
+    [Storable]
+    public int AffectedGroup { get; protected set; }
     [Storable]
     public int Index { get; protected set; }
@@ -38,9 +41,11 @@
     protected ChangePositionMove(ChangePositionMove original, Cloner cloner)
       : base(original, cloner) {
+      this.AffectedGroup = original.AffectedGroup;
       this.Index = original.Index;
       this.TargetIndex = original.TargetIndex;
     }
-    public ChangePositionMove(int index, int targetIndex, MultiComponentVectorEncoding multiComponentVector)
+    public ChangePositionMove(int affectedBin, int index, int targetIndex, MultiComponentVectorEncoding multiComponentVector)
       : base(multiComponentVector) {
+        AffectedGroup = affectedBin;
         Index = index;
         TargetIndex = targetIndex;
@@ -51,12 +56,12 @@
     }
 
-    public override MultiComponentVectorEncoding GetVectorAfterMove() {
-      return GetVectorAfterMove(MultiComponentVector, Index, TargetIndex);
+    public override IPackingSolutionEncoding GetSolutionAfterMove() {
+      return GetVectorAfterMove(MultiComponentVector, AffectedGroup, Index, TargetIndex);
     }
-    public static MultiComponentVectorEncoding GetVectorAfterMove(MultiComponentVectorEncoding multiComponentVector, int index, int targetIndex) {
+    public static MultiComponentVectorEncoding GetVectorAfterMove(MultiComponentVectorEncoding multiComponentVector, int affectedBin, int index, int targetIndex) {
       var result = multiComponentVector.Clone(new Cloner()) as MultiComponentVectorEncoding;
-      var aux = result.PackingInformations[index];
-      result.PackingInformations.RemoveAt(index);
-      result.PackingInformations.Insert(targetIndex, aux);
+      var aux = result.PackingInformations[affectedBin][index];
+      result.PackingInformations[affectedBin].Remove(aux);
+      result.PackingInformations[affectedBin].Insert(targetIndex, aux);
       return result;
     }
@@ -67,5 +72,30 @@
 
     public override string ToString() {
-      return "PM(i=" + Index + ",ti=" + TargetIndex + ")";
+      return "PM(g=" + AffectedGroup  + ",i=" + Index + ",ti=" + TargetIndex + ")";
+    }
+
+    public override MultiComponentVectorMoveAttribute GetAttribute(double quality) {
+      return new ChangePositionMoveAttribute(AffectedGroup, Index,
+        MultiComponentVector.PackingInformations[AffectedGroup][Index].ItemID,
+        TargetIndex, quality);
+    }
+
+    public override bool BelongsToAttribute(MultiComponentVectorMoveAttribute attribute, bool hardCriterion) {
+      ChangePositionMoveAttribute actualAttribute = attribute as ChangePositionMoveAttribute;
+      if (actualAttribute != null) {
+        if (hardCriterion) {
+          if (Index == actualAttribute.Index
+          || TargetIndex == actualAttribute.TargetIndex
+          || MultiComponentVector.PackingInformations[AffectedGroup][Index].ItemID == actualAttribute.ItemID)
+            return true;
+        } else {
+          if (Index == actualAttribute.Index
+          && TargetIndex == actualAttribute.TargetIndex
+          && MultiComponentVector.PackingInformations[AffectedGroup][Index].ItemID == actualAttribute.ItemID)
+            return true;
+        }
+      }
+
+      return false;
     }
   }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/MCVTripleMove.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/MCVTripleMove.cs	(revision 9494)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/MCVTripleMove.cs	(revision 9495)
@@ -24,33 +24,38 @@
 using HeuristicLab.Encodings.PackingEncoding.MultiComponentVector;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.BinPacking.Interfaces;
 
 namespace HeuristicLab.Encodings.PackingEncoding.MultiComponentVector {
   [Item("MCVTripleMove", "A move on a multi component vector that is specified by a rotation-value, two indexes and a groupNr.")]
   [StorableClass]
-  public class MCVTripleMove : MultiComponentVectorMove {
+  public class MCVTripleMove : MultiComponentVectorMove {   
     [Storable]
-    public int Index { get; protected set; }
+    public int OldGroup { get; protected set; }
+    [Storable]
+    public int NewGroup { get; protected set; }
+    [Storable]
+    public int Index { get; protected set; }    
+    [Storable]
+    public int TargetIndex { get; protected set; }
     [Storable]
     public bool Rotation { get; protected set; }
-    [Storable]
-    public int Group { get; protected set; }
-    [Storable]
-    public int TargetIndex { get; protected set; }
 
     [StorableConstructor]
     protected MCVTripleMove(bool deserializing) : base(deserializing) { }
     protected MCVTripleMove(MCVTripleMove original, Cloner cloner)
-      : base(original, cloner) {
-      this.Index = original.Index;
+      : base(original, cloner) {     
+      this.OldGroup = original.OldGroup;
+      this.NewGroup = original.NewGroup;
+      this.Index = original.Index;       
+      this.TargetIndex = original.TargetIndex;
       this.Rotation = original.Rotation;
-      this.Group = original.Group;
-      this.TargetIndex = original.TargetIndex;
     }
-    public MCVTripleMove(int index, bool rotation, int group, int targetIndex, MultiComponentVectorEncoding multiComponentVector)
-      : base(multiComponentVector) {
-        Index = index;
+    public MCVTripleMove(int oldGroup, int newGroup, int index, int targetIndex, bool rotation, MultiComponentVectorEncoding multiComponentVector)
+      : base(multiComponentVector) { 
+        OldGroup = oldGroup;
+        NewGroup = newGroup;
+        Index = index;        
+        TargetIndex = targetIndex;
         Rotation = rotation;
-        Group = group;
-        TargetIndex = targetIndex;
     }
 
@@ -59,12 +64,15 @@
     }
 
-    public override MultiComponentVectorEncoding GetVectorAfterMove() {
-      var result = MultiComponentVector;
+    public override IPackingSolutionEncoding GetSolutionAfterMove() {
+      var result = MultiComponentVector.Clone(new Cloner()) as MultiComponentVectorEncoding;
       if (Rotation)
-        result = SingleItemRotationMove.GetVectorAfterMove(MultiComponentVector, Index);
-      if (!MultiComponentVector.PackingInformations[Index].AssignedBin.Equals(Group))
-        result = SingleGroupingMove.GetVectorAfterMove(result, Index, Group);
-      if (!Index.Equals(TargetIndex))
-        result = ChangePositionMove.GetVectorAfterMove(result, Index, TargetIndex);
+        result = SingleItemRotationMove.GetVectorAfterMove(result, OldGroup, Index);
+      if (!OldGroup.Equals(NewGroup)) {
+        result = SingleGroupingMove.GetVectorAfterMove(result, OldGroup, Index, NewGroup);
+        int newIndex = result.PackingInformations[NewGroup].Count - 1;
+        if (!newIndex.Equals(TargetIndex))
+          result = ChangePositionMove.GetVectorAfterMove(result, NewGroup, newIndex, TargetIndex);
+      } else if (!Index.Equals(TargetIndex))
+          result = ChangePositionMove.GetVectorAfterMove(result, NewGroup, Index, TargetIndex);
       return result;
     }
@@ -75,5 +83,30 @@
 
     public override string ToString() {
-      return "TM(i=" + Index + ",r=" + Rotation + ",g=" + Group + ",ti=" + TargetIndex + ")";
+      return "TM(og=" + OldGroup + ",ng=" + NewGroup + ",i=" + Index + ",ti=" + TargetIndex + ",r=" + Rotation + ")";
+    }
+
+
+    public override MultiComponentVectorMoveAttribute GetAttribute(double quality) {
+      return new MCVTripleMoveAttribute(Index, TargetIndex, MultiComponentVector.PackingInformations[OldGroup][Index].ItemID,
+        Rotation, OldGroup, NewGroup, quality);
+    }
+
+    public override bool BelongsToAttribute(MultiComponentVectorMoveAttribute attribute, bool hardCriterion) {
+      MCVTripleMoveAttribute actualAttribute = attribute as MCVTripleMoveAttribute;
+      if (actualAttribute != null) {
+        if (hardCriterion) {
+          if ((Index == actualAttribute.Index && TargetIndex == actualAttribute.TargetIndex)
+                  || MultiComponentVector.PackingInformations[OldGroup][Index].ItemID == actualAttribute.ItemID
+                  || (OldGroup == actualAttribute.GroupBefore && NewGroup == actualAttribute.GroupAfter))
+            return true;
+        } else {
+          if ((Index == actualAttribute.Index && TargetIndex == actualAttribute.TargetIndex)
+                  && MultiComponentVector.PackingInformations[OldGroup][Index].ItemID == actualAttribute.ItemID
+                  && Rotation == actualAttribute.Rotation
+                  && (OldGroup == actualAttribute.GroupBefore && NewGroup == actualAttribute.GroupAfter))
+            return true;
+        }
+      }
+      return false;
     }
   }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/MultiComponentVectorMove.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/MultiComponentVectorMove.cs	(revision 9494)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/MultiComponentVectorMove.cs	(revision 9495)
@@ -25,9 +25,10 @@
 using HeuristicLab.Encodings.PackingEncoding.MultiComponentVector;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.BinPacking.Interfaces;
 
 namespace HeuristicLab.Encodings.PackingEncoding.MultiComponentVector {
   [Item("MultiComponentVectorMove", "An abstract move for a multi component vector encoded solution.")]
   [StorableClass]
-  public abstract class MultiComponentVectorMove : Item {
+  public abstract class MultiComponentVectorMove : Item, IPackingMove {
     [Storable]
     public MultiComponentVectorEncoding MultiComponentVector { get; protected set; }
@@ -45,6 +46,8 @@
     }
 
-    public abstract MultiComponentVectorEncoding GetVectorAfterMove();
+    public abstract IPackingSolutionEncoding GetSolutionAfterMove();
     public abstract Type GetMoveAttributeType();
+    public abstract MultiComponentVectorMoveAttribute GetAttribute(double quality);
+    public abstract bool BelongsToAttribute (MultiComponentVectorMoveAttribute attribute, bool hardCriterion);
   }
 }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/SingleGroupingMove.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/SingleGroupingMove.cs	(revision 9494)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/SingleGroupingMove.cs	(revision 9495)
@@ -24,9 +24,12 @@
 using HeuristicLab.Encodings.PackingEncoding.MultiComponentVector;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.BinPacking.Interfaces;
 
 namespace HeuristicLab.Encodings.PackingEncoding.MultiComponentVector {
   [Item("SingleGroupingMove", "A move on a multi component vector that is specified by a single index and a new grouping-value. The grouping of the item on the specified index is changed to the new value.")]
   [StorableClass]
-  public class SingleGroupingMove : MultiComponentVectorMove {
+  public class SingleGroupingMove : MultiComponentVectorMove {       
+    [Storable]
+    public int OldGroup { get; protected set; }
     [Storable]
     public int Index { get; protected set; }
@@ -38,11 +41,13 @@
     protected SingleGroupingMove(SingleGroupingMove original, Cloner cloner)
       : base(original, cloner) {
+      this.OldGroup = original.OldGroup;
       this.Index = original.Index;
       this.NewGroup = original.NewGroup;
     }
-    public SingleGroupingMove(int index, int newGroup, MultiComponentVectorEncoding multiComponentVector)
+    public SingleGroupingMove(int oldGroup, int index, int newGroup, MultiComponentVectorEncoding multiComponentVector)
       : base(multiComponentVector) {
-      Index = index;
-      NewGroup = newGroup;
+        OldGroup = oldGroup;
+        Index = index;
+        NewGroup = newGroup;
     }
 
@@ -51,15 +56,12 @@
     }
 
-    public override MultiComponentVectorEncoding GetVectorAfterMove() {
-      return GetVectorAfterMove(MultiComponentVector, Index, NewGroup);
+    public override IPackingSolutionEncoding GetSolutionAfterMove() {
+      return GetVectorAfterMove(MultiComponentVector, OldGroup, Index, NewGroup);
     }
-    public static MultiComponentVectorEncoding GetVectorAfterMove(MultiComponentVectorEncoding originalSolution, int itemIndex, int binNr) {
+    public static MultiComponentVectorEncoding GetVectorAfterMove(MultiComponentVectorEncoding originalSolution, int oldBin, int index, int newBin) {
       var solution = originalSolution.Clone (new Cloner()) as MultiComponentVectorEncoding;
-      var itemgene = solution.PackingInformations[itemIndex];
-      solution.PackingInformations.Remove(itemgene);
-      itemgene.AssignedBin = binNr;
-      int targetIndex = solution.PackingInformations.FindLastIndex(pi => pi.AssignedBin == binNr);
-      solution.PackingInformations.Insert(targetIndex + 1, itemgene);
-      //solution.PackingInformations[itemIndex].AssignedBin = binNr;
+      var itemgene = solution.PackingInformations[oldBin][index];
+      solution.PackingInformations[oldBin].Remove(itemgene);
+      solution.PackingInformations[newBin].Add(itemgene);
       return solution;
     }
@@ -70,5 +72,26 @@
 
     public override string ToString() {
-      return "GM(i="+Index+",g="+NewGroup+")";
+      return "GM(og"+OldGroup+",i="+Index+",ng="+NewGroup+")";
+    }
+
+    public override MultiComponentVectorMoveAttribute GetAttribute(double quality) {
+      return new SingleGroupingMoveAttribute(OldGroup, Index,
+        MultiComponentVector.PackingInformations[OldGroup][Index].ItemID, NewGroup, quality);
+    }
+
+    public override bool BelongsToAttribute(MultiComponentVectorMoveAttribute attribute, bool hardCriterion) {
+      SingleGroupingMoveAttribute actualAttribute = attribute as SingleGroupingMoveAttribute;
+      if (actualAttribute != null) {
+        if (hardCriterion) {
+          if (MultiComponentVector.PackingInformations[OldGroup][Index].ItemID == actualAttribute.ItemID
+                || NewGroup == actualAttribute.NewGroup)
+            return true;
+        } else {
+          if (MultiComponentVector.PackingInformations[OldGroup][Index].ItemID == actualAttribute.ItemID
+                && NewGroup == actualAttribute.NewGroup)
+            return true;
+        }
+      }
+      return false;
     }
   }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/SingleItemRotationMove.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/SingleItemRotationMove.cs	(revision 9494)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/SingleItemRotationMove.cs	(revision 9495)
@@ -24,4 +24,5 @@
 using HeuristicLab.Encodings.PackingEncoding.MultiComponentVector;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.BinPacking.Interfaces;
 
 namespace HeuristicLab.Encodings.PackingEncoding.MultiComponentVector {
@@ -30,5 +31,7 @@
   public class SingleItemRotationMove : MultiComponentVectorMove {
     [Storable]
-    public int ItemIndex { get; protected set; }
+    public int AffectedGroup { get; protected set; }
+    [Storable]
+    public int Index { get; protected set; }
 
     [StorableConstructor]
@@ -36,9 +39,11 @@
     protected SingleItemRotationMove(SingleItemRotationMove original, Cloner cloner)
       : base(original, cloner) {
-        this.ItemIndex = original.ItemIndex;
+        this.AffectedGroup = original.AffectedGroup;
+        this.Index = original.Index;
     }
-    public SingleItemRotationMove(int index, MultiComponentVectorEncoding multiComponentVector)
+    public SingleItemRotationMove(int affectedBin, int index, MultiComponentVectorEncoding multiComponentVector)
       : base(multiComponentVector) {
-        ItemIndex = index;
+        AffectedGroup = affectedBin;
+        Index = index;
     }
 
@@ -47,10 +52,10 @@
     }
 
-    public override MultiComponentVectorEncoding GetVectorAfterMove() {
-      return GetVectorAfterMove (MultiComponentVector, ItemIndex);
+    public override IPackingSolutionEncoding GetSolutionAfterMove() {
+      return GetVectorAfterMove (MultiComponentVector, AffectedGroup, Index);
     }
-    public static MultiComponentVectorEncoding GetVectorAfterMove(MultiComponentVectorEncoding multiComponentVector, int itemIndex) {
+    public static MultiComponentVectorEncoding GetVectorAfterMove(MultiComponentVectorEncoding multiComponentVector, int affectedGroup, int index) {
       var result = multiComponentVector.Clone(new Cloner()) as MultiComponentVectorEncoding;
-      result.PackingInformations[itemIndex].Rotated = !result.PackingInformations[itemIndex].Rotated;
+      result.PackingInformations[affectedGroup][index].Rotated = !result.PackingInformations[affectedGroup][index].Rotated;
       return result;
     }
@@ -61,5 +66,25 @@
 
     public override string ToString() {
-      return "RM(i=" + ItemIndex+")";
+      return "RM(g=" + AffectedGroup + ",i=" + Index + ")";
+    }
+
+    public override MultiComponentVectorMoveAttribute GetAttribute(double quality) {
+        return new SingleItemRotationMoveAttribute(AffectedGroup, Index, 
+          MultiComponentVector.PackingInformations[AffectedGroup][Index].ItemID, 
+          MultiComponentVector.PackingInformations[AffectedGroup][Index].Rotated, quality);
+    }
+
+    public override bool BelongsToAttribute(MultiComponentVectorMoveAttribute attribute, bool hardCriterion) {
+      SingleItemRotationMoveAttribute actualAttribute = attribute as SingleItemRotationMoveAttribute;
+      if (actualAttribute != null) {
+        if (hardCriterion) {
+          if (AffectedGroup == actualAttribute.AffectedGroup || MultiComponentVector.PackingInformations[AffectedGroup][Index].Rotated == actualAttribute.ItemRotation)
+            return true;
+        } else {
+          if (AffectedGroup == actualAttribute.AffectedGroup && MultiComponentVector.PackingInformations[AffectedGroup][Index].Rotated == actualAttribute.ItemRotation)
+            return true;
+        }
+      }
+      return false;
     }
   }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/SwapPositionMove.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/SwapPositionMove.cs	(revision 9494)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/SwapPositionMove.cs	(revision 9495)
@@ -24,4 +24,5 @@
 using HeuristicLab.Encodings.PackingEncoding.MultiComponentVector;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.BinPacking.Interfaces;
 
 namespace HeuristicLab.Encodings.PackingEncoding.MultiComponentVector {
@@ -29,4 +30,6 @@
   [StorableClass]
   public class SwapPositionMove : MultiComponentVectorMove {
+    [Storable]
+    public int AffectedGroup { get; protected set; }
     [Storable]
     public int Index1 { get; protected set; }
@@ -38,9 +41,11 @@
     protected SwapPositionMove(SwapPositionMove original, Cloner cloner)
       : base(original, cloner) {
-      this.Index1 = original.Index1;
-      this.Index2 = original.Index2;
+        this.AffectedGroup = original.AffectedGroup;
+        this.Index1 = original.Index1;
+        this.Index2 = original.Index2;
     }
-    public SwapPositionMove(int index1, int index2, MultiComponentVectorEncoding multiComponentVector)
+    public SwapPositionMove(int affectedGroup, int index1, int index2, MultiComponentVectorEncoding multiComponentVector)
       : base(multiComponentVector) {
+        AffectedGroup = affectedGroup;
         Index1 = index1;
         Index2 = index2;
@@ -51,12 +56,12 @@
     }
 
-    public override MultiComponentVectorEncoding GetVectorAfterMove() {
-      return GetVectorAfterMove(MultiComponentVector, Index1, Index2);
+    public override IPackingSolutionEncoding GetSolutionAfterMove() {
+      return GetVectorAfterMove(MultiComponentVector, AffectedGroup, Index1, Index2);
     }
-    public static MultiComponentVectorEncoding GetVectorAfterMove(MultiComponentVectorEncoding multiComponentVector, int index1, int index2) {
+    public static MultiComponentVectorEncoding GetVectorAfterMove(MultiComponentVectorEncoding multiComponentVector, int affectedGroup, int index1, int index2) {
       var result = multiComponentVector.Clone(new Cloner()) as MultiComponentVectorEncoding;
-      var aux = result.PackingInformations[index1];
-      result.PackingInformations[index1] = result.PackingInformations[index2];
-      result.PackingInformations[index2] = aux;
+      var aux = result.PackingInformations[affectedGroup][index1];
+      result.PackingInformations[affectedGroup][index1] = result.PackingInformations[affectedGroup][index2];
+      result.PackingInformations[affectedGroup][index2] = aux;
       return result;
     }
@@ -67,5 +72,31 @@
 
     public override string ToString() {
-      return "SM(i1=" + Index1 + ",i2=" + Index2 + ")";
+      return "SPM(g=" + AffectedGroup + ",i1=" + Index1 + ",i2=" + Index2 + ")";
+    }
+
+    public override MultiComponentVectorMoveAttribute GetAttribute(double quality) {
+      return new SwapPositionMoveAttribute(AffectedGroup, Index1, Index2,
+        MultiComponentVector.PackingInformations[AffectedGroup][Index1].ItemID,
+        MultiComponentVector.PackingInformations[AffectedGroup][Index2].ItemID, quality);
+    }
+
+    public override bool BelongsToAttribute(MultiComponentVectorMoveAttribute attribute, bool hardCriterion) {
+      SwapPositionMoveAttribute actualAttribute = attribute as SwapPositionMoveAttribute;
+      if (actualAttribute != null) {
+        if (hardCriterion) {
+          if (Index1 == actualAttribute.Index1
+            || Index2 == actualAttribute.Index2
+            || MultiComponentVector.PackingInformations[AffectedGroup][Index1].ItemID == actualAttribute.ItemID1
+            || MultiComponentVector.PackingInformations[AffectedGroup][Index2].ItemID == actualAttribute.ItemID2)
+            return true;
+        } else {
+          if (Index1 == actualAttribute.Index1
+            && Index2 == actualAttribute.Index2
+            && MultiComponentVector.PackingInformations[AffectedGroup][Index1].ItemID == actualAttribute.ItemID1
+            && MultiComponentVector.PackingInformations[AffectedGroup][Index2].ItemID == actualAttribute.ItemID2)
+            return true;
+        }
+      }
+      return false;
     }
   }
